package com.xs.leetcode.editor.en;

import java.util.Arrays;
import java.util.Scanner;

public class AggressiveCows {
    private boolean isOk(int N, int C, int[] X, int d) {
        int cnt = 1;
        int i = 0;
        for (int j = i + 1; j < N; j++) {
            if (X[j] >= X[i] + d) {
              cnt++;
              i = j;
            }
        }
        if (cnt >= C) return true;
        return false;
    }
    private int aggressiveCows(int N, int C, int[] X) {
        Arrays.sort(X);
        int min = 1;
        int max = (X[N - 1] - X[0]) / (C - 1);
        int beg = min;
        int end = max + 1;
        int mid;
        while (beg < end - 1) {
            mid = beg + (end - beg) / 2;
            if (isOk(N, C, X, mid)) beg = mid;
            else end = mid;
        }
        return beg;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        int C = scanner.nextInt();
        int[] X = new int[N];
        for (int i = 0; i < N; i++) {
            X[i] = scanner.nextInt();
        }
        AggressiveCows aggressiveCows = new AggressiveCows();
        int res = aggressiveCows.aggressiveCows(N, C, X);
        System.out.println(res);
    }
}
